HttpClient.Redirect (Java SE 10 & JDK 10 )
Keywords: jdk.incubator.http.HttpClient.Redirect class

Module jdk.incubator.httpclient
Package jdk.incubator.http

## Enum HttpClient.Redirect

- java.lang.Object
- - java.lang.Enum<HttpClient.Redirect>
  - - jdk.incubator.http.HttpClient.Redirect

- All Implemented Interfaces:
    `Serializable`, `Comparable<HttpClient.Redirect>`
  Enclosing class:
    HttpClient

      public static enum HttpClient.Redirect
      extends Enum<HttpClient.Redirect>

  Defines automatic redirection policy.
  Incubating Feature. Will be removed in a future release.

  This is checked whenever a `3XX` response code is received. If redirection does not happen automatically then the response is returned to the user, where it can be handled manually.

  `Redirect` policy is set via the `HttpClient.Builder.followRedirects(HttpClient.Redirect)` method.

  Since:
    9

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `ALWAYS` | Always redirect.
    `NEVER` | Never redirect.
    `SAME_PROTOCOL` | Redirect to same protocol only.
    `SECURE` | Redirect always except from HTTPS URLs to HTTP URLs.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static HttpClient.Redirect` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
    `static HttpClient.Redirect[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods declared in class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods declared in class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### NEVER

          public static final HttpClient.Redirect NEVER

      Never redirect.

    - #### ALWAYS

          public static final HttpClient.Redirect ALWAYS

      Always redirect.

    - #### SAME_PROTOCOL

          public static final HttpClient.Redirect SAME_PROTOCOL

      Redirect to same protocol only. Redirection may occur from HTTP URLs to other HTTP URLs, and from HTTPS URLs to other HTTPS URLs.

    - #### SECURE

          public static final HttpClient.Redirect SECURE

      Redirect always except from HTTPS URLs to HTTP URLs.

  - ### Method Detail

    - #### values

          public static HttpClient.Redirect[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (HttpClient.Redirect c : HttpClient.Redirect.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static HttpClient.Redirect valueOf​(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null